test_gns_dht_lookup.sh 2.5 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364
  1. #!/bin/sh
  2. # This file is in the public domain.
  3. trap "gnunet-arm -e -c test_gns_lookup.conf" INT
  4. which timeout > /dev/null 2>&1 && DO_TIMEOUT="timeout 30"
  5. LOCATION=$(which gnunet-config)
  6. if [ -z $LOCATION ]
  7. then
  8. LOCATION="gnunet-config"
  9. fi
  10. $LOCATION --version 1> /dev/null
  11. if test $? != 0
  12. then
  13. echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
  14. exit 77
  15. fi
  16. TEST_IP="127.0.0.1"
  17. MY_EGO="myego"
  18. OTHER_EGO="delegatedego"
  19. rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
  20. gnunet-arm -s -c test_gns_lookup.conf
  21. gnunet-arm -i zonemaster -c test_gns_lookup.conf
  22. gnunet-arm -i datastore -c test_gns_lookup.conf
  23. gnunet-identity -C $OTHER_EGO -c test_gns_lookup.conf
  24. DELEGATED_PKEY=$(gnunet-identity -d -c test_gns_lookup.conf | grep $OTHER_EGO | awk '{print $3}')
  25. gnunet-identity -C $MY_EGO -c test_gns_lookup.conf
  26. gnunet-namestore -p -z $MY_EGO -a -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
  27. #This works
  28. gnunet-namestore -p -z $OTHER_EGO -a -n www -t A -V $TEST_IP -e never -c test_gns_lookup.conf
  29. #This doesn't
  30. gnunet-namestore -p -z $OTHER_EGO -a -n www2 -t A -V $TEST_IP -e '5 s' -c test_gns_lookup.conf
  31. sleep 6
  32. #gnunet-namestore -p -z $OTHER_EGO -d -n www2 -t A -V $TEST_IP -e '5 s' -c test_gns_lookup.conf
  33. #gnunet-namestore -p -z $OTHER_EGO -a -n www2 -t A -V $TEST_IP -e '5 s' -c test_gns_lookup.conf
  34. gnunet-arm -k zonemaster -c test_gns_lookup.conf
  35. gnunet-arm -i zonemaster -c test_gns_lookup.conf
  36. #gnunet-arm -r -c test_gns_lookup.conf
  37. #gnunet-arm -i zonemaster
  38. #gnunet-arm -i gns -c test_gns_lookup.conf
  39. gnunet-arm -I -c test_gns_lookup.conf
  40. #gnunet-identity -D $OTHER_EGO -c test_gns_lookup.conf
  41. #gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
  42. #gnunet-namestore -z $OTHER_EGO -d -n www -t A -V $TEST_IP -e never -c test_gns_lookup.conf
  43. RES_IP=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
  44. RES_IP_REL=`$DO_TIMEOUT gnunet-gns --raw -u www2.b.$MY_EGO -t A -c test_gns_lookup.conf`
  45. #gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
  46. gnunet-arm -I -c test_gns_lookup.conf
  47. gnunet-arm -e -c test_gns_lookup.conf
  48. rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
  49. if [ "$RES_IP_REL" != "$TEST_IP" ]
  50. then
  51. echo "Failed to resolve to proper IP, got $RES_IP_REL. (relative expiration)"
  52. #exit 1
  53. fi
  54. if [ "$RES_IP" = "$TEST_IP" ]
  55. then
  56. exit 0
  57. else
  58. echo "Failed to resolve to proper IP, got $RES_IP."
  59. exit 1
  60. fi